program evolution;
type
   person=record
            namenum:word;
            male:boolean;
            birthround:word;
            mother:word;  {65535=no parents}
            father:word;
            age:byte;
            hp:integer;
            heatresistance:boolean;
            bodycooling:boolean;
            auxheatresistance:boolean;
            auxbodycooling:boolean;
            marriedto:word;  {65535 not married}
            survival:word;
            alive:boolean;
          end;

const
  deletethedead=false;
  marriages=true;
  agestep=5;
  heal=16*agestep;
  starthp=50;
  malepercentage=50;
  creaturemax=500;

  allowbirth:boolean=true;
  round:word=0;
  heat:byte=100;
  creaturenum:integer=0;
  alivenum:word=0;
  maxname=21;
  name:array[0..maxname] of string[12]=
  ('Adam',  'Eve',       'Thomas',  'Christine','Siegfried','Hildegard','Stefan'
  ,'Tina',  'Kain',      'Rebecca' ,'Abel',     'Nadya'    ,'Sigmund'  ,'Leila',
   'Fritz', 'Karin',     'Walter',  'Wilfriede','Ingo',     'Niki',     'Franz',
   'Elvira');

var getticks:longint absolute $40:$6c;


var
  creature:array[0..creaturemax] of person;
  a:word;

procedure delay(ticks:longint);
var
  a:longint;
begin
  a:=getticks;
  repeat
  until getticks-ticks>=a;
end;

procedure setup;
begin
  with creature[creaturenum] do
  begin
    namenum:=creaturenum;
    male:=true;
    birthround:=0;
    mother:=$ffff;
    father:=$ffff;
    age:=agestep*8;
    hp:=starthp;
    heatresistance:=boolean(random(2));
    bodycooling:=boolean(random(2));
    auxheatresistance:=boolean(random(2));
    auxbodycooling:=boolean(random(2));
    marriedto:=1;
    survival:=0;
    alive:=true;
    inc(creaturenum);
    inc(alivenum);
  end;
  with creature[creaturenum] do
  begin
    namenum:=creaturenum;
    male:=false;
    birthround:=0;
    mother:=$ffff;
    father:=$ffff;
    age:=agestep*8;
    hp:=starthp;
    heatresistance:=boolean(random(2));
    bodycooling:=boolean(random(2));
    auxheatresistance:=boolean(random(2));
    auxbodycooling:=boolean(random(2));
    marriedto:=0;
    survival:=0;
    alive:=true;
    inc(creaturenum);
    inc(alivenum);
  end;
  with creature[creaturenum] do
  begin
    namenum:=creaturenum;
    male:=true;
    birthround:=0;
    mother:=$ffff;
    father:=$ffff;
    age:=agestep*8;
    hp:=starthp;
    heatresistance:=boolean(random(2));
    bodycooling:=boolean(random(2));
    auxheatresistance:=boolean(random(2));
    auxbodycooling:=boolean(random(2));
    marriedto:=3;
    survival:=0;
    alive:=true;
    inc(creaturenum);
    inc(alivenum);
  end;
  with creature[creaturenum] do
  begin
    namenum:=creaturenum;
    male:=false;
    birthround:=0;
    mother:=$ffff;
    father:=$ffff;
    age:=agestep*8;
    hp:=starthp;
    heatresistance:=boolean(random(2));
    bodycooling:=boolean(random(2));
    auxheatresistance:=boolean(random(2));
    auxbodycooling:=boolean(random(2));
    survival:=0;
    marriedto:=2;
    alive:=true;
    inc(creaturenum);
    inc(alivenum);
  end;
end;

procedure decreasehp(num:word);
begin
  with creature[num] do
  begin
    if heatresistance and bodycooling then dec(hp,heat div 20) else
    if heatresistance then dec(hp,heat div 10) else
    if bodycooling then dec(hp,heat div 8) else dec(hp,15);
    inc(hp,heal div age);
    if hp>starthp then hp:=starthp;
    inc(age,agestep);
  end;
end;

procedure searchpartners1(var temp1,temp2:word);
var
  a,b,c:word;
begin
  b:=0;
  repeat
    a:=random(creaturenum);
    inc(b);
  until (((marriages and (creature[a].marriedto=$ffff)) or not marriages) and
        creature[a].alive)
        or (b>creaturenum);
  if (b<=creaturenum) and not (creaturenum=1) then temp1:=a else temp1:=65535;
  if (b<=creaturenum) and not (creaturenum=1) then
  begin
    b:=0;
    c:=a;
    repeat
      repeat
        a:=random(creaturenum);
      until a<>c;
      inc(b);
    until (((marriages and (creature[a].marriedto=$ffff)) or not marriages)
          and (creature[a].male<>creature[temp1].male) and creature[a].alive)
          or (b>creaturenum);
    if b>creaturenum then temp1:=65535 else temp2:=a;
  end;
end;

procedure searchpartners2(var temp1,temp2:word);
var b:word;
begin
  b:=0;
  repeat
    temp1:=random(creaturenum);
    inc(b);
  until ((creature[temp1].marriedto<>$ffff) and creature[temp1].alive)
        or (b>creaturemax);
  if b<creaturemax then temp2:=creature[temp1].marriedto else temp1:=65535;
end;

procedure crossover(var a,b:boolean;c,d,e,f:boolean);
begin
  if random(2)=0 then
  begin
    if random(2)=0 then a:=c else a:=d;
    if random(2)=0 then b:=e else b:=f;
  end else
  begin
    if random(2)=0 then a:=e else a:=f;
    if random(2)=0 then b:=c else b:=d;
  end;
end;

procedure birth(partner1,partner2:word);
var
  a:word;
begin
  if marriages then creature[partner1].marriedto:=partner2;
  if marriages then creature[partner2].marriedto:=partner1;
  with creature[creaturenum] do
  begin
    a:=random(100);
    if a<malepercentage then
    begin
      namenum:=random(maxname) div 2*2;
      male:=true;
    end else
    begin
      namenum:=random(maxname)div 2*2+1;
      male:=false;
    end;
    if creature[partner1].male then
    begin
      mother:=partner2;
      father:=partner1;
    end else
    begin
      mother:=partner1;
      father:=partner2;
    end;
    age:=agestep;
    hp:=starthp;
    marriedto:=$ffff;
    survival:=0;
    alive:=true;
    birthround:=round;
    crossover(heatresistance,auxheatresistance,creature[partner1].heatresistance,creature[partner1].auxheatresistance,
                                               creature[partner2].heatresistance,creature[partner2].auxheatresistance);
    crossover(bodycooling,auxbodycooling,creature[partner1].bodycooling,creature[partner1].auxbodycooling,
                                         creature[partner2].heatresistance,creature[partner2].auxheatresistance);
  end;
  inc(creaturenum);
  inc(alivenum);
end;

procedure doround;
var
  a,b,temp1,temp2:word;
begin
  inc(round);
  writeln('ROUND ',round);
  a:=0;
  repeat
  with creature[a] do
  begin
    if alive then
    begin
      decreasehp(a);
      if hp<1 then
      begin
        writeln(name[namenum],' dies having lived ',survival,' rounds!');
        if creature[a].marriedto<>$ffff then creature[creature[a].marriedto].marriedto:=$ffff;
        if deletethedead then
        begin
          if a<creaturenum-1 then
          begin
            move(creature[a+1],creature[a],sizeof(creature)-(a+1)*sizeof(person));
            for temp1:=a to creaturenum-1 do if creature[temp1].marriedto<>$ffff then dec(creature[temp1].marriedto);
          end;
          dec(creaturenum);
        end else creature[a].alive:=false;
        dec(alivenum);
      end else inc(survival);
    end;
  end;
  inc(a);
  until a>=creaturenum;
  for b:=0 to 1 do
  begin
    if (creaturenum<=creaturemax) and allowbirth then
    begin
      searchpartners1(temp1,temp2);
      if temp1=65535 then searchpartners2(temp1,temp2);
      if temp1<>$ffff then
      begin
        if creature[temp1].male=false then
        begin
          a:=temp1;
          temp1:=temp2;
          temp2:=a;
        end;
        write(name[creature[temp1].namenum],' and ',name[creature[temp2].namenum],' give birth to ');
        birth(temp1,temp2);
        writeln(name[creature[creaturenum-1].namenum]);
      end;
    end;
  end;
end;

begin
  randseed:=10;
  asm
    mov ax,0003h
    int 10h
  end;

  writeln('EVOLVE  Program for simulating evolution');
  writeln('   Copyright 1994 Matthias Benkmann');
  writeln;

  setup;
  repeat
    heat:=80+random(40);
    doround;
   { for a:=1 to creaturenum do if creature[a-1].alive then write(name[creature[a-1].namenum],' ');}
   { writeln;
    repeat until port[$60]<128;}
    delay(10);
  until (round=250) or (alivenum=0);
  if alivenum=0 then writeln('EVERY CREATURE HAS PERISHED! SIMULATION FINISHED');
  for a:=1 to creaturenum do write('S:',creature[a-1].survival,'  B:',creature[a-1].birthround,'     ');
end.







